/*****************************************************************************
/ Assignment 3 Part 2: Application                                          
/ Cigarette-Smoker Problem
/ Description:  Agent gives out two material out of three; tobacco, matches, 
/               paper.
/               3 Smoker, each with only one of the three materials.
/               Smoker can smoke only when agent gives out the other missing
/               two materials.  
/               Synchronize the four people.
/****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "minithread.h"
#include "synch.h"

#define CANCER_STICKS_TO_SMOKE 1000

#ifndef FALSE 
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE 1
#endif


volatile int match   = FALSE;
volatile int paper   = FALSE;
volatile int tobacco = FALSE;
volatile int timeToStop = FALSE;

semaphore_t lock, smoker1, smoker2, smoker3, agent;

static int
Smoker1()
{
  /*this thread has matches*/
  while(!timeToStop)
    {
      semaphore_P(smoker1);
      semaphore_V(lock);
      if(paper && tobacco)
	{
	  printf("Smoker1 (match) puffing away...\n");
	  paper = FALSE;
	  tobacco = FALSE;
	  semaphore_V(agent);
	}
      semaphore_V(lock);
    }
  return 1;
}

static int
Smoker2()
{ 
  /*this thread has paper*/
  while(!timeToStop)
    {
      semaphore_P(smoker2);
      semaphore_P(lock);
      if(match && tobacco)
	{
	  printf("Smoker2 (paper) puffing away...\n");
	  match = FALSE;
	  tobacco = FALSE;
	  semaphore_V(agent);
	}
      semaphore_V(lock);
    }
  return 1;
}

static int
Smoker3()
{
  /*this thread has tobacco*/
  while(!timeToStop)
    {
      semaphore_P(smoker3);
      semaphore_P(lock);
      if(paper && match)
	{
	  printf("Smoker3 (tobacco) puffing away...\n");
	  paper = FALSE;
	  match = FALSE;
	  semaphore_V(agent);
	}
      semaphore_V(lock);
    }
  return 1;
} 


static int
Agent()
{ 
	/* this thread puts out two of three items and then yeilds */

  int i;
  int missing = 0;

  minithread_t s1,s2,s3;

  lock = semaphore_create();
  semaphore_initialize(lock, 1);
  smoker1 = semaphore_create();
  semaphore_initialize(smoker1, 0);
  smoker2 = semaphore_create();
  semaphore_initialize(smoker2, 0);
  smoker3 = semaphore_create();
  semaphore_initialize(smoker3, 0);
  agent = semaphore_create();
  semaphore_initialize(agent, 0);
  s1 = minithread_fork(Smoker1, NULL);
  s2 = minithread_fork(Smoker2, NULL);
  s3 = minithread_fork(Smoker3, NULL);

  for(i=0; i < CANCER_STICKS_TO_SMOKE; i++)
    {
      missing = random() % 3;
      semaphore_P(lock);
      match   = TRUE;
      paper   = TRUE;
      tobacco = TRUE;
      switch (missing)
	{
	case 0: /* no matches */
	  match = FALSE;
	  printf("Agent puts paper and tobacco on the table.\n");
	  break;
	case 1: /* no paper */
	  paper   = FALSE;
	  printf("Agent puts matches and tobacco on the table.\n");
	  break;
	case 2: /* no tobacco */
	  tobacco = FALSE;
	  printf("Agent puts paper and matches on the table.\n");
	  break;
	}
      semaphore_V(lock);
      semaphore_V(smoker1);
      semaphore_V(smoker2);
      semaphore_V(smoker3);
      semaphore_P(agent);
    }
  /* time to stop this chuck wagon */
  timeToStop = TRUE;
  printf("Cigarette players got cancer and died off\n"); 
  return 1;
}


main()
{
  minithread_system_initialize(Agent, NULL);
}

