/*
 * my_malloc.c (safe malloc for the preemptive minithread system)
 *
 * Sung-Eun Choi (sungeun@cs.washington.edu)
 * Autumn 1996
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include "clock.h"

void *my_malloc(unsigned int s)
{
  void *d;
  boolean_t i;

  i = interrupts;
  interrupts = DISABLED;

  d = malloc(s);

  interrupts = i;

  return d;

}

void my_free(void *d)
{
  boolean_t i;

  i = interrupts;
  interrupts = DISABLED;

  free(d);

  interrupts = i;

}

