#include <stdio.h>
#include <time.h>
#include "minithread.h"
#include "synch.h"
#include "my_malloc.h"

#define NUMBER_OF_ITERATIONS 10000
#define NUMBER_OF_THREADS 10

int global_counter=0;
semaphore_t mutex;

semaphore_t tester_wait_semaphore;

void test(arg_t name)
{
  int i;
  int local_counter = 0;
   
  for (i=0; i< NUMBER_OF_ITERATIONS; i++)
    {
      semaphore_P(mutex);
      global_counter++;
      semaphore_V(mutex);

      local_counter++;
    }
  
  fprintf(stdout, "I am %d thread. (local_counter = %d, global_counter = %d)\n", *(int*)name, local_counter, global_counter);

  semaphore_V(tester_wait_semaphore);

}

static int tester()
{
  int i;
  int* j; 

  tester_wait_semaphore = semaphore_create();
  semaphore_initialize(tester_wait_semaphore, - NUMBER_OF_THREADS + 1);

  mutex = semaphore_create();
  semaphore_initialize(mutex, 1);
  srandom(time(NULL));

  for (i=0; i<NUMBER_OF_THREADS; i++) {
    j = (int*)my_malloc(sizeof(int));
    *j = i;
    minithread_fork((proc_t)&test, (arg_t)j);
  }
  semaphore_P(tester_wait_semaphore);

  fprintf(stdout, "All threads terminated. Final global_counter = %d\n", global_counter);
}

main()
{
  minithread_system_initialize(tester, NULL);
}


